/*====================================================================
		rmath.h

		rFunc InterBase UDF library.
		Math functions.

		Copyright 1998-2001 Polaris Software
		http://polesoft.da.ru
		mailto: rFunc@mail.ru

		Version 2.0.1.2
====================================================================== */

#ifndef _RMATH_H
#define _RMATH_H

double EXPORT fn_abs(ARG(double*, x));
double EXPORT fn_maxnum(ARG(double*, x), ARG(double*, y));
double EXPORT fn_minnum(ARG(double*, x), ARG(double*, y));

double EXPORT fn_ceil(ARG(double*, x));
double EXPORT fn_floor(ARG(double*, x));
double EXPORT fn_power(ARG(double*, x), ARG(double*, y));

double EXPORT fn_round(ARG(double*, x), ARG(long*, n));
double EXPORT fn_softround(ARG(double*, x), ARG(long*, n));

long EXPORT fn_div(long* q, long* r);
long EXPORT fn_mod(long* q, long* r);

double EXPORT fn_z(ARG(double*, a));
double EXPORT fn_dividezero(ARG(double*, a), ARG(double*, b), ARG(double*, def));

long EXPORT fn_initRandom(ARG(long *, num));
long EXPORT fn_getRandom(ARG(long *, num));

long EXPORT fn_getBit(ARG(long *, num), ARG(long *, shift));
long EXPORT fn_setBit(ARG(long *, num), ARG(long *, shift), ARG(long *, val));
long EXPORT fn_bitAnd(ARG(long *, a), ARG(long *, b));
long EXPORT fn_bitOr(ARG(long *, a), ARG(long *, b));
long EXPORT fn_bitXor(ARG(long *, a), ARG(long *, b));
long EXPORT fn_bitNot(ARG(long *, num));

#endif